# ArcGISTiledElevationTerrainProvider

#### new Cesium.ArcGISTiledElevationTerrainProvider(options)
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 234

To construct a CesiumTerrainProvider, call `ArcGISTiledElevationTerrainProvider.fromUrl`. Do not call the constructor directly.
A `TerrainProvider` that produces terrain geometry by tessellating height maps retrieved from Elevation Tiles of an an ArcGIS ImageService.

Name | Type | Description
--- | --- | ---
`options` | CesiumTerrainProvider.ConstructorOptions | optional A url or an object describing initialization options

##### Example:

    const terrainProvider = await Cesium.ArcGISTiledElevationTerrainProvider.fromUrl("https://elevation3d.arcgis.com/arcgis/rest/services/WorldElevation3D/Terrain3D/ImageServer", {
      token: "KED1aF_I4UzXOHy3BnhwyBHU4l5oY6rO6walkmHoYqGp4XyIWUd5YZUC1ZrLAzvV40pR6gBXQayh0eFA8m6vPg.."
    });
    viewer.terrainProvider = terrainProvider;

##### See:

- TerrainProvider

### Members

#### readonly availability : TileAvailability
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 329

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This property may be undefined if availability information is not available.

#### readonly credit : Credit
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 278

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain.

#### readonly errorEvent : Event
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 265

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : boolean
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 316

Gets a value indicating whether or not the requested tiles include vertex normals.

#### readonly hasWaterMask : boolean
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 304

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves.

#### readonly tilingScheme : GeographicTilingScheme
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 290

Gets the tiling scheme used by this provider.

### Methods

#### static Cesium.ArcGISTiledElevationTerrainProvider.fromUrl(url, options) → Promise.<ArcGISTiledElevationTerrainProvider>
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 353

Creates a `TerrainProvider` that produces terrain geometry by tessellating height maps retrieved from Elevation Tiles of an an ArcGIS ImageService.

Name | Type | Description
--- | --- | ---
`url` | Resource | String | Promise.<Resource> | Promise.<String> | The URL of the ArcGIS ImageServer service.
`options` | ArcGISTiledElevationTerrainProvider.ConstructorOptions | optional A url or an object describing initialization options.

##### Returns:

##### Throws:

- RuntimeError : metadata specifies invalid spatial reference
- RuntimeError : metadata does not specify tileInfo

##### Example:

    const terrainProvider = await Cesium.ArcGISTiledElevationTerrainProvider.fromUrl("https://elevation3d.arcgis.com/arcgis/rest/services/WorldElevation3D/Terrain3D/ImageServer", {
      token: "KED1aF_I4UzXOHy3BnhwyBHU4l5oY6rO6walkmHoYqGp4XyIWUd5YZUC1ZrLAzvV40pR6gBXQayh0eFA8m6vPg.."
    });
    viewer.terrainProvider = terrainProvider;

#### getLevelMaximumGeometricError(level) → number
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 498

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → boolean|undefined
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 512

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 539

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.

##### Returns:

This provider does not support loading availability.

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 399

Requests the geometry for a given tile. The result includes terrain data and indicates that all child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | number | The X coordinate of the tile for which to request geometry.
`y` | number | The Y coordinate of the tile for which to request geometry.
`level` | number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

### Type Definitions

#### Cesium.ArcGISTiledElevationTerrainProvider.ConstructorOptions
engine/Source/Core/ArcGISTiledElevationTerrainProvider.js 24

Initialization options for the ArcGISTiledElevationTerrainProvider constructor

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`token` | string | <optional> | The authorization token to use to connect to the service.
`ellipsoid` | Ellipsoid | <optional> | The ellipsoid. If the tilingScheme is specified, this parameter is ignored and the tiling scheme's ellipsoid is used instead. If neither parameter is specified, the WGS84 ellipsoid is used.

Need help? The fastest way to get answers is from the community and team on the Cesium Forum.